package com.nisum.webfluxmongodbordermanagement.controller;

import com.nisum.webfluxmongodbordermanagement.entity.Order;
import com.nisum.webfluxmongodbordermanagement.entity.UserOrders;
import com.nisum.webfluxmongodbordermanagement.service.OrdersService;
import com.nisum.webfluxmongodbordermanagement.service.UserOrdersService;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.reactive.WebFluxTest;
import org.springframework.boot.test.mock.mockito.MockBean;
import org.springframework.test.context.junit.jupiter.SpringExtension;
import org.springframework.test.web.reactive.server.WebTestClient;
import reactor.core.publisher.Flux;
import reactor.test.StepVerifier;

import java.util.Arrays;
import java.util.List;

import static org.mockito.Mockito.when;

@ExtendWith(SpringExtension.class)
@WebFluxTest(UserOrdersController.class)
public class UserOrderControllerTest {



    @Autowired
    private WebTestClient webTestClient;


    @MockBean
    private UserOrdersService userOrdersService;

    @BeforeEach
    void setUp() {
    }

    @AfterEach
    void tearDown() {
    }

    @Test
    void getAllUsers() {
    }

    @Test
    public void testGetUsersAndOrders() {
        // Mock data
        Flux<UserOrders> order = Flux.just(new UserOrders("1", "01", "sama","sama@gmail.com",
                Arrays.asList(new Order("1","123","01","oppo1234","oppo23bvn1","success"),
                        new Order("2","1234","01","vivo1234","vivo23bvn1","success"))));
        when(userOrdersService.getAllUsersWithOrders()).thenReturn(order);

        Flux<UserOrders> responseBody = webTestClient.get().uri("/user-orders")
                .exchange()
                .expectStatus().isOk()
                .returnResult(UserOrders.class)
                .getResponseBody();
//
        StepVerifier.create(responseBody)
                .expectSubscription()
                .expectNextMatches(p -> p.getUserId().equals("01"))
                .verifyComplete();
    }

}


